/**
 * Created by IntelliJ IDEA.
 * User: wrobel221
 * Date: 04.10.11
 * Time: 22:02
 * To change this template use File | Settings | File Templates.
 */
package rl {
import org.robotlegs.mvcs.Context;
import org.robotlegs.mvcs.SignalContext;

import rl.controller.GoHomeCommand;

import rl.controller.GoToSectionCommand;
import rl.model.SectionMap;
import rl.signal.GoHomeSignal;

import rl.signal.GoToSectionSignal;

import rl.view.ClientsView;
import rl.view.HomeView;
import rl.model.NavigatorManager;
import rl.view.PortfolioView;
import rl.view.mediator.ClientsMediator;
import rl.view.mediator.HomeMediator;
import rl.view.mediator.MobileRLMediator;
import rl.view.mediator.PortfolioMediator;
import rl.vo.ClientsData;
import rl.vo.PortfolioData;

import spark.components.ViewNavigator;
import spark.components.ViewNavigatorApplication;

public class MobileRLContext extends SignalContext {
    override public function startup():void {
        injector.mapValue(ViewNavigator, (contextView as ViewNavigatorApplication).navigator)

        mediatorMap.mapView(ClientsView, ClientsMediator);
        mediatorMap.mapView(HomeView, HomeMediator);
        mediatorMap.mapView(PortfolioView, PortfolioMediator);

        injector.mapSingleton(NavigatorManager);

        var sectionMap:SectionMap = new SectionMap();
        sectionMap[Section.CLIENTS] = ClientsView;
        sectionMap[Section.PORTFOLIO] = PortfolioView;
        injector.mapValue(SectionMap, sectionMap);

        var sectionDataMap:SectionDataMap = new SectionDataMap();
        sectionDataMap[Section.CLIENTS] = new ClientsData();
        sectionDataMap[Section.PORTFOLIO] = new PortfolioData();
        injector.mapValue(SectionDataMap, sectionDataMap);

        signalCommandMap.mapSignalClass(GoToSectionSignal, GoToSectionCommand);
        signalCommandMap.mapSignalClass(GoHomeSignal, GoHomeCommand);

        mediatorMap.mapView(MobileRL, MobileRLMediator);

        super.startup();
    }
}
}
